package org.nfunk.jep.function;

import java.util.Stack;
import org.nfunk.jep.ParseException;
import org.nfunk.jep.type.Complex;

public class UMinus extends PostfixMathCommand {
  public void run(Stack paramStack) throws ParseException {
    checkStack(paramStack);
    Object object = paramStack.pop();
    paramStack.push(umin(object));
  }
  
  public Object umin(Object paramObject) throws ParseException {
    if (paramObject instanceof Complex)
      return ((Complex)paramObject).neg(); 
    if (paramObject instanceof Number)
      return new Double(-((Number)paramObject).doubleValue()); 
    throw new ParseException("Invalid parameter type");
  }
}
